package org.springblade.flow.test;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springblade.core.test.BladeBootTest;
import org.springblade.core.test.BladeSpringExtension;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.flow.engine.entity.FlowModel;
import org.springblade.flow.engine.service.FlowEngineService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Random;


/**
 * Blade单元测试
 *
 * @author Chill
 */
@ExtendWith(BladeSpringExtension.class)
@BladeBootTest(appName = "blade-flow", enableLoader = true)
public class BladeTest {

	@Autowired
	private FlowEngineService service;

	@Test
	public void contextLoads() {
		System.out.println("=====数据迁移启动=====");

		// 获取 ACT_DE_MODEL 表需要转换的数据
		List<FlowModel> list = service.list();
		// 循环转换
		list.forEach(flowModel -> {
			if (StringUtil.isBlank(flowModel.getModelEditorXml())) {
				service.update(Wrappers.<FlowModel>lambdaUpdate()
					.set(FlowModel::getModelEditorXml, new String(service.getModelEditorXML(flowModel)))
					.ge(FlowModel::getId, flowModel.getId())
				);
			}
		});

		System.out.println("=====数据迁移完毕=====");
	}


	public static void main(String[] args) {

		String codev=getCharAndNumr(32);
		System.out.println(codev);


	}

	/**
	 * 方法1：生成随机数字和字母组合
	 * @param length
	 * @return
	 */

	public static String getCharAndNumr(int length) {

		Random random = new Random();

		StringBuffer valSb = new StringBuffer();

		String charStr = "0123456789abcdefghijklmnopqrstuvwxyz";

		int charLength = charStr.length();



		for (int i = 0; i < length; i++) {

			int index = random.nextInt(charLength);

			valSb.append(charStr.charAt(index));

		}

		return valSb.toString();

	}

}
